#include <bits/stdc++.h>

using namespace std;

int n, q;
int niz[200010];

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(0);
    
    cin>>n>>q;

    for (int i=1; i<=n; i++)
        cin>>niz[i];

    long long ress;
    for (int i=0; i<q; i++)
    {
        int l, r;
        cin>>l>>r;
        ress=niz[l];
        for (int j=l; j<=r; j++)
            ress&=niz[j];
        cout<<ress<<endl;
    }
}